VERSION 5.00
Begin VB.UserControl PreviewText 
   ClientHeight    =   375
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1305
   ScaleHeight     =   375
   ScaleWidth      =   1305
   ToolboxBitmap   =   "PreviewText.ctx":0000
   Begin VB.TextBox txtInput 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "mnuPopup"
      Begin VB.Menu mnuPopupCut 
         Caption         =   "Cu&t"
         Shortcut        =   ^X
      End
      Begin VB.Menu mnuPopupCopy 
         Caption         =   "&Copy"
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuPopupPaste 
         Caption         =   "&Paste"
         Shortcut        =   ^V
      End
      Begin VB.Menu mnuPopupDelete 
         Caption         =   "&Delete"
         Shortcut        =   {DEL}
      End
      Begin VB.Menu mnuPopupSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuPopupSelectAll 
         Caption         =   "Select &All"
         Shortcut        =   ^A
      End
   End
End
Attribute VB_Name = "PreviewText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Event declarations.
Public Event BeforeChange(ByVal new_value As String, ByRef Cancel As Boolean)
' See what the new value would be
' if this change is allowed.
Private Function NewValue(ByVal KeyValue As Integer, ByVal is_delete As Boolean) As String
' Useful ASCII codes.
Const ASC_CTRL_V = 22
Const ASC_CTRL_X = 24
Const FIRST_ASC = 32    ' 1st visible char.
Const LAST_ASC = 126    ' Last visible char.

Dim old_txt As String
Dim part1 As String
Dim part2 As String
Dim part3 As String

    old_txt = txtInput.Text

    ' Find the pieces before and after the selection.
    part1 = Left$(old_txt, txtInput.SelStart)
    part3 = Right$(old_txt, Len(old_txt) - txtInput.SelStart - txtInput.SelLength)

    ' Calculate the new text.
    part2 = ""
    If is_delete Then
        ' This is a delete character.
        ' If no text is selected, delete the
        ' following character (if there is one).
        If (txtInput.SelLength <= 0) And _
           (Len(part3) > 0) _
        Then
            part3 = Mid$(part3, 2)
        End If

        ' If text is selected or part3 is blank,
        ' just leave part2 = "".
    Else
        ' This is not a delete character.
        ' See what it is.
        Select Case KeyValue
            Case vbKeyBack      ' Backspace.
                ' If no text is selected, delete the
                ' previous character (if there is one).
                If (txtInput.SelLength <= 0) And _
                   (Len(part1) > 0) _
                Then
                    part1 = Left$(part1, Len(part1) - 1)
                End If
                ' If text is selected or part1 is
                ' blank, leave part2 = "".

            Case ASC_CTRL_V
                ' Paste the clipboard's text over
                ' the selected text.
                part2 = Clipboard.GetText(vbCFText)

            Case ASC_CTRL_X
                ' Leave part2 = "".

            Case FIRST_ASC To LAST_ASC
                ' Use the visible character typed
                ' for the middle string.
                part2 = Chr$(KeyValue)

            Case Else
                ' Assume other non-visible keys
                ' like ^C will not change the text.
                NewValue = old_txt
                Exit Function
        End Select
    End If

    ' Build the result.
    NewValue = part1 & part2 & part3
End Function
' Copy the selected text to the clipboard.
Private Sub mnuPopupCopy_Click()
    txtInput.SetFocus
    SendKeys "^C"
End Sub
' Copy selected text to the clipboard and clear it.
Private Sub mnuPopupCut_Click()
    txtInput.SetFocus
    SendKeys "^X"
End Sub

' Clear the selected text.
Private Sub mnuPopupDelete_Click()
    txtInput.SetFocus

    ' If any text is selected, treat as Delete.
    If txtInput.SelLength > 0 Then SendKeys "{DELETE}"
End Sub


' Paste the clipboard's text if appropriate.
Private Sub mnuPopupPaste_Click()
    txtInput.SetFocus
    SendKeys "^V"
End Sub
' Select all the text.
Private Sub mnuPopupSelectAll_Click()
    txtInput.SelStart = 0
    txtInput.SelLength = Len(txtInput.Text)
    txtInput.SetFocus
End Sub
' Watch for Delete keys.
Private Sub txtInput_KeyDown(KeyCode As Integer, Shift As Integer)
Dim new_value As String
Dim Cancel As Boolean

    If KeyCode = vbKeyDelete Then
        ' See what the new value would be.
        new_value = NewValue(KeyCode, True)

        ' Tell the program.
        RaiseEvent BeforeChange(new_value, Cancel)
        If Cancel Then KeyCode = 0
    End If
End Sub

' Validate key presses.
Private Sub txtInput_KeyPress(KeyAscii As Integer)
Dim new_value As String
Dim Cancel As Boolean

    ' See what the new value would be.
    new_value = NewValue(KeyAscii, False)

    ' Tell the program.
    RaiseEvent BeforeChange(new_value, Cancel)
    If Cancel Then KeyAscii = 0
End Sub
' Replace the standard context menu with our own.
Private Sub txtInput_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbRightButton Then
        ' Make Visual Basic discard the mouse capture.
        txtInput.Enabled = False
        txtInput.Enabled = True

        ' Display the popup menu.
        PopupMenu mnuPopup
    End If
End Sub

' Make txtInput as wide as possible. Make the
' control's height fit txtInput.
Private Sub UserControl_Resize()
    txtInput.Move 0, 0, ScaleWidth
    Height = txtInput.Height
End Sub

' Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    txtInput.Text = PropBag.ReadProperty("Text", "")
End Sub

' Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Text", txtInput.Text, ""
End Sub
' Return the field's text (delegated to txtInput).
Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text contained in the control."
    Text = txtInput.Text
End Property

' Set the field's text (delegated to txtInput).
Public Property Let Text(ByVal New_Text As String)
    txtInput.Text = New_Text
    PropertyChanged "Text"
End Property
